local AddonName, GGL = ...

local Export = {}
GGL.Export = Export

-- lua
local type = type
local concate = table.concat
local gsub = string.gsub

-- wow

-- other

-- ########################################
-- Base
-- ########################################



-- ########################################
-- csv
-- ########################################

local function CSV_FormatStringWithDelimiter(str, delimiter)
    if not delimiter or type(str) ~= "string" then
        return str
    end

    return gsub(str, delimiter, "")
end

local function CSV_FormatTableStrings(tab, delimiter)
    local newTab = {}
    for i = 1, #tab do
        newTab[i] = CSV_FormatStringWithDelimiter(tab[i], delimiter)
    end
    return concate(newTab, delimiter)
end

--- Get a csv string
-- tab = {
--      header = {"pos1", "pos2"},  -- header
--      {1,2} -- index rows
-- }
-- @param       delimiter       <string>
function Export:ExportAsCSV(tab, delimiter, noHeader)
    if not tab then return end

    delimiter = delimiter or ","

    local csv = {}

    -- check if we have header
    if not noHeader and tab.header then
        csv[1] = CSV_FormatTableStrings(tab.header, delimiter)
    end

    -- get entrys
    for i = 1, #tab do
        csv[#csv+1] = CSV_FormatTableStrings(tab[i], delimiter)
    end

    return concate(csv, "\n")
end