local AddonName, GGL_Util = ...

local select, tonumber = select, tonumber
local strsplit = strsplit
local bit_band = bit.band

local CombatLogGetCurrentEventInfo = CombatLogGetCurrentEventInfo

-- https://wow.gamepedia.com/UnitFlag
local COMBATLOG_OBJECT_REACTION_HOSTILE = 0x00000040
local COMBATLOG_OBJECT_TYPE_PLAYER = 0x00000400

local eventFrame = CreateFrame("FRAME")
eventFrame:RegisterEvent("COMBAT_LOG_EVENT_UNFILTERED")

local function GetNpcIDFromGuid(guid)
	local npcID = select(6,strsplit("-",guid))
	if npcID then
		return tonumber(npcID)
	end
end

local function OnEvent(self, event, ...)
    local _, subEvent, _, _, _, _, _, destGUID, destName, destFlags = CombatLogGetCurrentEventInfo()

    if subEvent == "UNIT_DIED" and destFlags then
        -- enemy and not a player
        if bit_band(destFlags, COMBATLOG_OBJECT_REACTION_HOSTILE) ~= 0 and bit_band(destFlags, COMBATLOG_OBJECT_TYPE_PLAYER) == 0 then
            local npcID = GetNpcIDFromGuid(destGUID)
            if npcID then
                GoldGoblinLootDataDB["npc_names"][npcID] = destName
            end
        end
    end
end

eventFrame:SetScript("OnEvent", OnEvent)